/*
 *  This file if part of nzbget
 *
 *  Copyright (C) 2004  Sven Henkel <sidddy@users.sourceforge.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Revision: 1.2 $
 * $Date: 2004/07/28 17:24:08 $
 *
 */

#ifndef COLORED_FRONTEND_H
#define COLORED_FRONTEND_H

#include <vector>
#include <pthread.h>
#include <time.h>

#include "Thread.h"
#include "Frontend.h"


class ColoredFrontend : public Frontend
{
 public:

    ColoredFrontend();

    virtual ~ColoredFrontend();

    virtual void frontendError(char* msg);

    virtual void frontendWarn(char* msg);

    virtual void frontendDebug(char* msg);

    virtual void frontendInfo(char* msg);

    virtual void frontendQueueListEntry( const char* szEntry );
    
    virtual void printStatus();

 protected:

};

#endif
